CREATE PROCEDURE CAP_COMPRESSION(IN current_sample_percentage DECIMAL(38,2))
LANGUAGE SQLSCRIPT
AS
BEGIN

TRUNCATE TABLE GT_CAP_LEVEL_1;
TRUNCATE TABLE GT_CAP_LEVEL_2;
TRUNCATE TABLE GT_CAP_LEVEL_3;
TRUNCATE TABLE GT_CAP_LEVEL_4;
TRUNCATE TABLE GT_CAP_LEVEL_5;
TRUNCATE TABLE GT_CAP_LEVEL_5A;
TRUNCATE TABLE GT_CAP_LEVEL_5B;
TRUNCATE TABLE GT_CAP_LEVEL_5C;
TRUNCATE TABLE GT_CAP_LEVEL_6;
-- TRUNCATE TABLE GT_CAP_LEVEL_7;
TRUNCATE TABLE GT_CAP_LEVEL_8;
TRUNCATE TABLE GT_CAP_LEVEL_9;

 
--MESSAGE '1) DELETE CATL_TDS.RESULT_THRESHOLD ' to client DEBUG ONLY;
DELETE FROM CAP_RESULT_THRESHOLD WHERE EXISTS (SELECT 1 FROM CAP_RAW WHERE CAP_RAW.BATTERY_ID=CAP_RESULT_THRESHOLD.BATTERY_ID);
COMMIT;

--MESSAGE '2) INSERT INTO GT_CAP_LEVEL_1 ' to client DEBUG ONLY; -- Calculate S
INSERT INTO GT_CAP_LEVEL_1    
SELECT BATTERY_ID, VT_TIME, Y,
abs(
( LEAD(VT_TIME, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME) - LAG(VT_TIME, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME) )  *
(Y - LAG(Y, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME)) +
((LAG(Y, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME)) - LEAD(Y, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME)) * 
( VT_TIME  - LAG(VT_TIME, 1) OVER(PARTITION BY BATTERY_ID ORDER BY VT_TIME) )) ABS_s
FROM CAP_RAW ORDER BY 1,2;
COMMIT;

--MESSAGE '3) INSERT INTO GT_CAP_LEVEL_2 ' to client DEBUG ONLY; --Rank S
INSERT INTO GT_CAP_LEVEL_2 
SELECT BATTERY_ID, VT_TIME, Y, ABS_S,  RANK() OVER ( PARTITION BY BATTERY_ID ORDER BY ABS_S DESC )  
FROM GT_CAP_LEVEL_1
ORDER BY BATTERY_ID, VT_TIME;
COMMIT;
TRUNCATE TABLE GT_CAP_LEVEL_1;
COMMIT; 
-- 取点
--MESSAGE '4) INSERT INTO GT_CAP_LEVEL_3 ' to client DEBUG ONLY;   -- This step returns all records - = Column 6
INSERT INTO GT_CAP_LEVEL_3 
(ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N)
SELECT row_number() OVER (PARTITION BY FORCE.BATTERY_ID ORDER BY FORCE.BATTERY_ID), 
FORCE.BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S,
CASE when (ABS_S is null) or (RANK_S <= TO_INT(:current_sample_percentage*(B.ZIP_RANK_NUMBER-2)))
THEN FORCE.Y 
ELSE null
END
AS SELECTION
FROM GT_CAP_LEVEL_2 FORCE,(SELECT COUNT(1) ZIP_RANK_NUMBER, BATTERY_ID FROM CAP_RAW GROUP BY BATTERY_ID) B --INDEX (IDX_GT_CAP_LEVEL_2_1)
WHERE FORCE.BATTERY_ID=B.BATTERY_ID
ORDER BY FORCE.BATTERY_ID, VT_TIME;
TRUNCATE TABLE GT_CAP_LEVEL_2;
COMMIT; 

--MESSAGE '5) INSERT INTO GT_CAP_LEVEL_4 ' to client DEBUG ONLY; 
INSERT INTO GT_CAP_LEVEL_4 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, PREV_ROW, NEXT_ROW)
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,  K_PREV_ROW_NUM, K_LEAD_ROW_NUM
FROM (
SELECT *,
case when ( FIRST_N IS NULL) AND ( LAG( FIRST_N  , 1) OVER(PARTITION BY BATTERY_ID ORDER BY  VT_TIME) ) IS NOT NULL
THEN LAG( VT_TIME) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) ELSE NULL END  AS K_PREV_ROW_NUM,
case when ( FIRST_N IS NULL) AND ( LEAD( FIRST_N  , 1) OVER(PARTITION BY BATTERY_ID ORDER BY  VT_TIME) ) IS NOT NULL 
THEN LEAD( VT_TIME) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) ELSE NULL END AS K_LEAD_ROW_NUM  
FROM GT_CAP_LEVEL_3 ) TEMP_TAB
WHERE FIRST_N IS NULL;
COMMIT;

--MESSAGE '6) INSERT INTO GT_CAP_LEVEL_5 ' to client DEBUG ONLY;  
INSERT INTO GT_CAP_LEVEL_5 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,new_prev_row, new_next_row)
select ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, 
(case when prev_row is null then LAG( prev_row) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) else prev_row end) new_prev_row,
(case when next_row is null then lead( next_row) OVER (PARTITION BY BATTERY_ID ORDER BY VT_TIME ASC ) else next_row end) new_next_row
from 
(SELECT *  FROM GT_CAP_LEVEL_4 where prev_row is not NULL 
union 
SELECT *  FROM GT_CAP_LEVEL_4 where next_row is not NULL ) new_tab ;
TRUNCATE TABLE GT_CAP_LEVEL_4;
COMMIT;

--MESSAGE '7) INSERT INTO GT_CAP_LEVEL_5A ' to client DEBUG ONLY;  
INSERT INTO GT_CAP_LEVEL_5A (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,NEW_PREV_ROW, NEW_NEXT_ROW, 
 NEW_PREV_VT_TIME, NEW_PREV_FIRST_N)
select INX_TAB.ROW_NUM, INX_TAB.BATTERY_ID, INX_TAB.VT_TIME, INX_TAB.Y, INX_TAB.ABS_S, INX_TAB.RANK_S, INX_TAB.FIRST_N, INX_TAB.NEW_PREV_ROW, INX_TAB.NEW_NEXT_ROW, PREV_TAB.VT_TIME , PREV_TAB.FIRST_N
FROM GT_CAP_LEVEL_5 INX_TAB, GT_CAP_LEVEL_3 PREV_TAB--, 
WHERE   INX_TAB.BATTERY_ID = PREV_TAB.BATTERY_ID AND
INX_TAB.NEW_PREV_ROW = PREV_TAB.VT_TIME  ;
COMMIT;

--MESSAGE '8) INSERT INTO GT_CAP_LEVEL_5B ' to client DEBUG ONLY; 
INSERT INTO GT_CAP_LEVEL_5B (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N,NEW_PREV_ROW, NEW_NEXT_ROW,
 NEW_PREV_VT_TIME, NEW_PREV_FIRST_N, NEW_NEXT_VT_TIME, NEW_NEXT_FIRST_N)
select INX_TAB.ROW_NUM, INX_TAB.BATTERY_ID, INX_TAB.VT_TIME, INX_TAB.Y, INX_TAB.ABS_S, INX_TAB.RANK_S, INX_TAB.FIRST_N, INX_TAB.NEW_PREV_ROW, INX_TAB.NEW_NEXT_ROW, INX_TAB.NEW_PREV_VT_TIME, INX_TAB.NEW_PREV_FIRST_N, NEXT_TAB.VT_TIME , NEXT_TAB.FIRST_N
FROM  GT_CAP_LEVEL_5A INX_TAB, GT_CAP_LEVEL_3 NEXT_TAB
WHERE   INX_TAB.BATTERY_ID = NEXT_TAB.BATTERY_ID AND 
INX_TAB.NEW_NEXT_ROW = NEXT_TAB.VT_TIME;
TRUNCATE TABLE GT_CAP_LEVEL_5A;
COMMIT;
-- 取最近的点
INSERT INTO GT_CAP_LEVEL_5C 
select GT_TAB3.VT_TIME,  GT_TAB3.BATTERY_ID, MAX(INX_TAB.VT_TIME)
  FROM GT_CAP_LEVEL_3 GT_TAB3 ,GT_CAP_LEVEL_5B INX_TAB
WHERE GT_TAB3.FIRST_N IS NULL AND INX_TAB.VT_TIME <=  GT_TAB3.VT_TIME AND INX_TAB.BATTERY_ID=GT_TAB3.BATTERY_ID
GROUP BY GT_TAB3.BATTERY_ID, GT_TAB3.VT_TIME ;

COMMIT;

-- FIND K, B
--MESSAGE '9) INSERT INTO GT_CAP_LEVEL_6 ' to client DEBUG ONLY; 
INSERT INTO GT_CAP_LEVEL_6
SELECT  
GT_TAB3.ROW_NUM, GT_TAB3.BATTERY_ID, GT_TAB3.VT_TIME, GT_TAB3.Y, GT_TAB3.ABS_S, GT_TAB3.RANK_S, GT_TAB3.FIRST_N, 
(INX_TAB.new_PREV_FIRST_N - INX_TAB.new_NEXT_FIRST_N)/(INX_TAB.new_PREV_VT_TIME-INX_TAB.new_NEXT_VT_TIME)  AS K , 
(INX_TAB.new_PREV_FIRST_N - ((INX_TAB.new_PREV_FIRST_N - INX_TAB.new_NEXT_FIRST_N)/(INX_TAB.new_PREV_VT_TIME-INX_TAB.new_NEXT_VT_TIME) * INX_TAB.new_PREV_VT_TIME))  AS B,
INX_TAB.ROW_NUM AS INX_ROW_NUM, INX_TAB.NEW_PREV_ROW,  INX_TAB.new_PREV_VT_TIME, INX_TAB.new_PREV_FIRST_N,
INX_TAB.NEW_NEXT_ROW, INX_TAB.new_NEXT_VT_TIME, INX_TAB.new_NEXT_FIRST_N
FROM GT_CAP_LEVEL_3 GT_TAB3 ,GT_CAP_LEVEL_5B INX_TAB, GT_CAP_LEVEL_5C LEVEL_5C_TAB
WHERE GT_TAB3.FIRST_N IS NULL 
AND GT_TAB3.BATTERY_ID=LEVEL_5C_TAB.BATTERY_ID AND GT_TAB3.VT_TIME=LEVEL_5C_TAB.ROW_NUM 
AND INX_TAB.BATTERY_ID=LEVEL_5C_TAB.BATTERY_ID AND INX_TAB.VT_TIME=LEVEL_5C_TAB.INX_ROW_NUM ;

TRUNCATE TABLE GT_CAP_LEVEL_5C;
COMMIT;
TRUNCATE TABLE GT_CAP_LEVEL_5B;
COMMIT;



-- FIND 拟合电压y'    NEW_CAL_Y 
--MESSAGE '10) INSERT INTO GT_CAP_LEVEL_8 ' to client DEBUG ONLY;
INSERT INTO GT_CAP_LEVEL_8 (ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, K, B, CAL_MISSING, NEW_CAL_Y)
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, K, B, VT_TIME * K + B, VT_TIME * K + B AS NEW_CAL_Y FROM GT_CAP_LEVEL_6
UNION ALL
SELECT ROW_NUM, BATTERY_ID, VT_TIME, Y, ABS_S, RANK_S, FIRST_N, NULL, NULL, NULL, FIRST_N AS NEW_CAL_Y FROM GT_CAP_LEVEL_3
WHERE FIRST_N IS NOT NULL
ORDER BY 2, 1 ASC;
TRUNCATE TABLE GT_CAP_LEVEL_6;
COMMIT;
TRUNCATE TABLE GT_CAP_LEVEL_3;
COMMIT;

-- FIND MEANS
--MESSAGE '11) INSERT INTO GT_CAP_LEVEL_9 ' to client DEBUG ONLY;
INSERT INTO GT_CAP_LEVEL_9 
SELECT ROW_NUM, BATTERY_ID, VT_TIME,Y,ABS_S,RANK_S,FIRST_N,K,B,CAL_MISSING,NEW_CAL_Y, avg(Y) OVER (PARTITION BY BATTERY_ID ORDER BY BATTERY_ID ASC ) AS MEAN_Y 
, POWER(Y- NEW_CAL_Y,2) AS Y_MINUS_Y_SQR, POWER(Y-(avg(Y) OVER (PARTITION BY BATTERY_ID ORDER BY BATTERY_ID ASC )),2) AS Y_MINUS_Y_Y_SQR 
FROM GT_CAP_LEVEL_8   
ORDER BY BATTERY_ID, ROW_NUM;
TRUNCATE TABLE GT_CAP_LEVEL_8;
COMMIT;

-- FIND THRESHOLD CAPTAGE
--MESSAGE '12) INSERT INTO RESULT_THRESHOLD ' to client DEBUG ONLY;
INSERT INTO CAP_RESULT_THRESHOLD
SELECT BATTERY_ID, (1 - SQRT(SUM(Y_MINUS_Y_SQR)  / SUM(Y_MINUS_Y_Y_SQR)) )  AS R_SQRT
FROM  GT_CAP_LEVEL_9
GROUP BY BATTERY_ID
ORDER BY BATTERY_ID;

commit;
end ;


CREATE PROCEDURE DOZIP_CAP(OUT res varchar(2000))
AS
BEGIN
	/*============================================================
	参数：
	NONE_ZIP_UPPPER_NUMBER 压缩上限
	PRE_ZIP_NUMBER 压缩保留前N个点
	POST_ZIP_NUMBER 压缩保留后N个点
	R_SQUARED 拟合度
	START_SAMPLE_PERCENTAGE 开始压缩百分比
	SAMPLE_INCREASE 压缩步长
	OUT : 
	res varchar(2000)(IF SUCCESS RETURN 0	IF ERROR RETURN ERROR_CODE&ERROR_MESSAGE)
	==============================================================*/
	DECLARE pre_zip_number INTEGER :=10;
	DECLARE post_zip_number INTEGER :=10;
	DECLARE current_sample_percentage DECIMAL(38,2) :=0.1;
	DECLARE none_zip_uppper_number DECIMAL(38,2) :=50;
	DECLARE sample_increase DECIMAL(38,2) :=0.1;
	DECLARE targetR  DECIMAL(38,4) :=0.99; 
	DECLARE cnt INTEGER;
	DECLARE i INTEGER;
	DECLARE tl_cnt INTEGER :=0;
	
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SELECT 'SQL ERROR[' || ::SQL_ERROR_CODE || ']:' || ::SQL_ERROR_MESSAGE INTO res FROM DUMMY;
		UPDATE TECH_ZIP_STATUS A SET C_STATUS=2,MODIFIED_DATE_TIME=CURRENT_TIMESTAMP,MODIFIED_USER='JOB_USER' 
		WHERE EXISTS(SELECT 1 FROM "GT_NOT_ZIP_CAP_DATA_ALL" B 
		WHERE A.REMARK=B.REMARK AND A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID AND C_STATUS=0);
		TRUNCATE TABLE "GT_NOT_ZIP_CAP_DATA_ALL";
	END;
	
	SELECT COUNT(1) INTO cnt FROM MD_ZIP_CONFIG;
	IF :cnt <> 0 THEN
		SELECT START_SAMPLE_PERCENTAGE,SAMPLE_INCREASE,PRE_ZIP_NUMBER,POST_ZIP_NUMBER,NONE_ZIP_UPPPER_NUMBER 
		INTO current_sample_percentage,sample_increase,pre_zip_number,post_zip_number,none_zip_uppper_number 
		FROM MD_ZIP_CONFIG LIMIT 1;
		
		-- SELECT PRE_ZIP_NUMBER INTO pre_zip_number FROM 
		SELECT R_SQUARED INTO targetR FROM MD_ZIP_CONFIG LIMIT 1;
		
		SELECT COUNT(1) INTO tl_cnt FROM M_TEMPORARY_TABLES WHERE SCHEMA_NAME ='TES' AND TABLE_NAME = 'GT_NOT_ZIP_CAP_DATA_ALL';
		IF :tl_cnt=0 THEN
			CREATE GLOBAL TEMPORARY COLUMN TABLE "GT_NOT_ZIP_CAP_DATA_ALL"(
			REMARK NVARCHAR(80),
			ST_BUSINESS_CYCLE INTEGER,
			STEP_ID INTEGER
			);
		END IF;
		TRUNCATE TABLE "GT_NOT_ZIP_CAP_DATA_ALL";
		INSERT INTO "GT_NOT_ZIP_CAP_DATA_ALL"
		SELECT REMARK,ST_BUSINESS_CYCLE,STEP_ID FROM TECH_ZIP_STATUS WHERE C_STATUS=0;
		-- 小于NONE_ZIP_UPPPER_NUMBER无需压缩，直接进压缩库
		INSERT INTO TX_ZIP_PROCESS_DATA
		(
		HANDLE, SITE,REMARK,SFC,RESOURCE_ID,CHANNEL_ID,SEQUENCE_ID,CYCLE,STEP_ID,
		STEP_NAME,TEST_TIME_DURATION,TIMESTAMP,SV_IC_RANGE,SV_IV_RANGE,
		PV_VOLTAGE,PV_CURRENT,PV_IR,PV_TEMPERATURE,PV_CHARGE_CAPACITY,PV_DISCHARGE_CAPACITY,
		PV_CHARGE_ENERGY,PV_DISCHARGE_ENERGY,PV_SUB_CHANNEL_1,PV_SUB_CHANNEL_2,
		PV_SUB_CHANNEL_3,PV_SUB_CHANNEL_4,PV_SUB_CHANNEL_5,PV_SUB_CHANNEL_6,PV_DATA_FLAG,PV_WORK_TYPE,TX_IS_EXCEPTIONAL,
		TX_ALERT_CURRENT,TX_ALERT_VOLTAGE,TX_ALERT_TEMPERATURE,TX_ALERT_CAPACITY,TX_ALERT_DURATION,TX_ALERT_CATEGORY1,TX_ALERT_CATEGORY2,
		TX_ROOT_REMARK, ST_BUSINESS_CYCLE, ZIP_CATEGORY, CREATED_USER, MODIFIED_USER 
		)
		SELECT 'TxZipProcessDataBO:'||D.SITE||','||D.REMARK||','||D.SFC||','||D.RESOURCE_ID||','||D.CHANNEL_ID||','||D.SEQUENCE_ID||',C', 
		D.SITE,D.REMARK,D.SFC,D.RESOURCE_ID,D.CHANNEL_ID,D.SEQUENCE_ID,D.CYCLE,D.STEP_ID,
		D.STEP_NAME,D.TEST_TIME_DURATION,D.TIMESTAMP,D.SV_IC_RANGE,D.SV_IV_RANGE,
		D.PV_VOLTAGE,D.PV_CURRENT,D.PV_IR,D.PV_TEMPERATURE,D.PV_CHARGE_CAPACITY,D.PV_DISCHARGE_CAPACITY,
		D.PV_CHARGE_ENERGY,D.PV_DISCHARGE_ENERGY,D.PV_SUB_CHANNEL_1,D.PV_SUB_CHANNEL_2,
		D.PV_SUB_CHANNEL_3,D.PV_SUB_CHANNEL_4,D.PV_SUB_CHANNEL_5,D.PV_SUB_CHANNEL_6,
		D.PV_DATA_FLAG,D.PV_WORK_TYPE,D.TX_IS_EXCEPTIONAL,
		D.TX_ALERT_CURRENT,D.TX_ALERT_VOLTAGE,D.TX_ALERT_TEMPERATURE,D.TX_ALERT_CAPACITY,D.TX_ALERT_DURATION,D.TX_ALERT_CATEGORY1,D.TX_ALERT_CATEGORY2,
		D.TX_ROOT_REMARK, D.ST_BUSINESS_CYCLE, 'C', 'JOB_USER','JOB_USER'
		FROM (SELECT A.ST_BUSINESS_CYCLE, A.REMARK, A. STEP_ID FROM TX_ORIGINAL_PROCESS_DATA A, "GT_NOT_ZIP_CAP_DATA_ALL" B
		WHERE A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID AND A.REMARK = B.REMARK
		GROUP BY A.REMARK, A.ST_BUSINESS_CYCLE, A.STEP_ID
		HAVING COUNT(1)<=:none_zip_uppper_number) C, TX_ORIGINAL_PROCESS_DATA D
		WHERE C.ST_BUSINESS_CYCLE=D.ST_BUSINESS_CYCLE AND C.STEP_ID=D.STEP_ID AND C.REMARK = D.REMARK;
		COMMIT;
		
		UPDATE TECH_ZIP_STATUS A SET C_STATUS=1 ,MODIFIED_DATE_TIME=CURRENT_TIMESTAMP,MODIFIED_USER='JOB_USER'
		WHERE EXISTS(SELECT 1 FROM TX_ORIGINAL_PROCESS_DATA B , "GT_NOT_ZIP_CAP_DATA_ALL" C
		WHERE A.REMARK=B.REMARK AND A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID
		AND A.REMARK=B.REMARK AND A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID 
		GROUP BY C.REMARK, C.ST_BUSINESS_CYCLE, C.STEP_ID 
		HAVING COUNT(1)<=:none_zip_uppper_number); 
		COMMIT;
		
		
		CREATE LOCAL TEMPORARY COLUMN TABLE "#not_zip_cap_data" LIKE "GT_NOT_ZIP_CAP_DATA_ALL" WITH NO DATA;
		INSERT INTO "#not_zip_cap_data" SELECT A.REMARK,A.ST_BUSINESS_CYCLE,A.STEP_ID FROM "GT_NOT_ZIP_CAP_DATA_ALL" A, TX_ORIGINAL_PROCESS_DATA B
		WHERE A.REMARK=B.REMARK AND A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID 
		GROUP BY A.REMARK, A.ST_BUSINESS_CYCLE, A.STEP_ID 
		HAVING COUNT(1)>:none_zip_uppper_number;
		
		CREATE LOCAL TEMPORARY COLUMN TABLE "#zip_rawdata_inx"
		(
			REMARK NVARCHAR(200),
			ST_BUSINESS_CYCLE INTEGER,
			STEP_ID INTEGER,
			ROW_NUM INTEGER,
			SEQUENCE_ID INTEGER
		);
		INSERT INTO "#zip_rawdata_inx"
		SELECT B.REMARK,B.ST_BUSINESS_CYCLE, B.STEP_ID,row_number() OVER (PARTITION BY B.REMARK,B.ST_BUSINESS_CYCLE,B.STEP_ID ORDER BY B.SEQUENCE_ID), B.SEQUENCE_ID
		FROM "#not_zip_cap_data" A,"TX_ORIGINAL_PROCESS_DATA" B
		WHERE A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID AND A.REMARK = B.REMARK;
		
		TRUNCATE TABLE CAP_RAW;
		INSERT INTO CAP_RAW SELECT B.REMARK || ',' ||B.ST_BUSINESS_CYCLE|| ',' || B.STEP_ID, B.SEQUENCE_ID, 
		CASE WHEN B.PV_CHARGE_CAPACITY <> 0 THEN B.PV_CHARGE_CAPACITY ELSE PV_DISCHARGE_CAPACITY END 
		FROM "#not_zip_cap_data" A,"TX_ORIGINAL_PROCESS_DATA" B, 
		(SELECT REMARK, ST_BUSINESS_CYCLE, STEP_ID, COUNT(1) TOTAL 
		FROM TX_ORIGINAL_PROCESS_DATA GROUP BY REMARK, ST_BUSINESS_CYCLE, STEP_ID) C ,"#zip_rawdata_inx" D
		WHERE A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID AND A.REMARK = B.REMARK
		AND  A.ST_BUSINESS_CYCLE=C.ST_BUSINESS_CYCLE AND A.STEP_ID=C.STEP_ID AND A.REMARK = C.REMARK
		AND  A.ST_BUSINESS_CYCLE=D.ST_BUSINESS_CYCLE AND A.STEP_ID=D.STEP_ID AND A.REMARK = D.REMARK
		AND B.SEQUENCE_ID = D.SEQUENCE_ID
		AND (D.ROW_NUM >:pre_zip_number AND D.ROW_NUM<=(C.TOTAL-:post_zip_number));-- (NOT IN 10%)
		COMMIT;
		
		INSERT INTO TX_ZIP_PROCESS_DATA
		(
		HANDLE, SITE,REMARK,SFC,RESOURCE_ID,CHANNEL_ID,SEQUENCE_ID,CYCLE,STEP_ID,
		STEP_NAME,TEST_TIME_DURATION,TIMESTAMP,SV_IC_RANGE,SV_IV_RANGE,
		PV_VOLTAGE,PV_CURRENT,PV_IR,PV_TEMPERATURE,PV_CHARGE_CAPACITY,PV_DISCHARGE_CAPACITY,
		PV_CHARGE_ENERGY,PV_DISCHARGE_ENERGY,PV_SUB_CHANNEL_1,PV_SUB_CHANNEL_2,
		PV_SUB_CHANNEL_3,PV_SUB_CHANNEL_4,PV_SUB_CHANNEL_5,PV_SUB_CHANNEL_6,PV_DATA_FLAG,PV_WORK_TYPE,TX_IS_EXCEPTIONAL,
		TX_ALERT_CURRENT,TX_ALERT_VOLTAGE,TX_ALERT_TEMPERATURE,TX_ALERT_CAPACITY,TX_ALERT_DURATION,TX_ALERT_CATEGORY1,TX_ALERT_CATEGORY2,
		TX_ROOT_REMARK, ST_BUSINESS_CYCLE, ZIP_CATEGORY, CREATED_USER, MODIFIED_USER 
		) 
		SELECT 'TxZipProcessDataBO:'||B.SITE||','||B.REMARK||','||B.SFC||','||B.RESOURCE_ID||','||B.CHANNEL_ID||','||B.SEQUENCE_ID||',C', 
		B.SITE,B.REMARK,B.SFC,B.RESOURCE_ID,B.CHANNEL_ID,B.SEQUENCE_ID,B.CYCLE,B.STEP_ID,
		B.STEP_NAME,B.TEST_TIME_DURATION,B.TIMESTAMP,B.SV_IC_RANGE,B.SV_IV_RANGE,
		B.PV_VOLTAGE,B.PV_CURRENT,B.PV_IR,B.PV_TEMPERATURE,B.PV_CHARGE_CAPACITY,B.PV_DISCHARGE_CAPACITY,
		B.PV_CHARGE_ENERGY,B.PV_DISCHARGE_ENERGY,B.PV_SUB_CHANNEL_1,B.PV_SUB_CHANNEL_2,
		B.PV_SUB_CHANNEL_3,B.PV_SUB_CHANNEL_4,B.PV_SUB_CHANNEL_5,B.PV_SUB_CHANNEL_6,
		B.PV_DATA_FLAG,B.PV_WORK_TYPE,B.TX_IS_EXCEPTIONAL,
		B.TX_ALERT_CURRENT,B.TX_ALERT_VOLTAGE,B.TX_ALERT_TEMPERATURE,B.TX_ALERT_CAPACITY,B.TX_ALERT_DURATION,B.TX_ALERT_CATEGORY1,B.TX_ALERT_CATEGORY2,
		B.TX_ROOT_REMARK, B.ST_BUSINESS_CYCLE, 'C', 'JOB_USER','JOB_USER' 
		FROM "#not_zip_cap_data" A, TX_ORIGINAL_PROCESS_DATA B, 
		(SELECT REMARK, ST_BUSINESS_CYCLE, STEP_ID, COUNT(1) TOTAL 
		FROM TX_ORIGINAL_PROCESS_DATA GROUP BY REMARK, ST_BUSINESS_CYCLE, STEP_ID) C,"#zip_rawdata_inx" D
		WHERE A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID AND A.REMARK = B.REMARK 
		AND  A.ST_BUSINESS_CYCLE=C.ST_BUSINESS_CYCLE AND A.STEP_ID=C.STEP_ID AND A.REMARK = C.REMARK
		AND  A.ST_BUSINESS_CYCLE=D.ST_BUSINESS_CYCLE AND A.STEP_ID=D.STEP_ID AND A.REMARK = D.REMARK
		AND B.SEQUENCE_ID = D.SEQUENCE_ID
		AND (D.ROW_NUM<=:pre_zip_number OR D.ROW_NUM>(C.TOTAL-:post_zip_number));
		COMMIT;
		
		FOR i IN 1.. 100
		DO 
			
			SELECT COUNT(1) INTO cnt FROM CAP_RAW;
			IF :cnt=0 THEN 
				BREAK;
			END IF;
			IF :cnt>0 THEN
				CALL "CAP_COMPRESSION"(:current_sample_percentage);
			END IF;
			
			INSERT INTO TX_ZIP_PROCESS_DATA
			(
			HANDLE, SITE,REMARK,SFC,RESOURCE_ID,CHANNEL_ID,SEQUENCE_ID,CYCLE,STEP_ID,
			STEP_NAME,TEST_TIME_DURATION,TIMESTAMP,SV_IC_RANGE,SV_IV_RANGE,
			PV_VOLTAGE,PV_CURRENT,PV_IR,PV_TEMPERATURE,PV_CHARGE_CAPACITY,PV_DISCHARGE_CAPACITY,
			PV_CHARGE_ENERGY,PV_DISCHARGE_ENERGY,PV_SUB_CHANNEL_1,PV_SUB_CHANNEL_2,
			PV_SUB_CHANNEL_3,PV_SUB_CHANNEL_4,PV_SUB_CHANNEL_5,PV_SUB_CHANNEL_6,PV_DATA_FLAG,PV_WORK_TYPE,TX_IS_EXCEPTIONAL,
			TX_ALERT_CURRENT,TX_ALERT_VOLTAGE,TX_ALERT_TEMPERATURE,TX_ALERT_CAPACITY,TX_ALERT_DURATION,TX_ALERT_CATEGORY1,TX_ALERT_CATEGORY2,
			TX_ROOT_REMARK, ST_BUSINESS_CYCLE, ZIP_CATEGORY, CREATED_USER, MODIFIED_USER 
			)
			SELECT 'TxZipProcessDataBO:'||D.SITE||','||D.REMARK||','||D.SFC||','||D.RESOURCE_ID||','||D.CHANNEL_ID||','||D.SEQUENCE_ID||',C', 
			D.SITE,D.REMARK,D.SFC,D.RESOURCE_ID,D.CHANNEL_ID,D.SEQUENCE_ID,D.CYCLE,D.STEP_ID,
			D.STEP_NAME,D.TEST_TIME_DURATION,D.TIMESTAMP,D.SV_IC_RANGE,D.SV_IV_RANGE,
			D.PV_VOLTAGE,D.PV_CURRENT,D.PV_IR,D.PV_TEMPERATURE,D.PV_CHARGE_CAPACITY,D.PV_DISCHARGE_CAPACITY,
			D.PV_CHARGE_ENERGY,D.PV_DISCHARGE_ENERGY,D.PV_SUB_CHANNEL_1,D.PV_SUB_CHANNEL_2,
			D.PV_SUB_CHANNEL_3,D.PV_SUB_CHANNEL_4,D.PV_SUB_CHANNEL_5,D.PV_SUB_CHANNEL_6,
			D.PV_DATA_FLAG,D.PV_WORK_TYPE,D.TX_IS_EXCEPTIONAL,
			D.TX_ALERT_CURRENT,D.TX_ALERT_VOLTAGE,D.TX_ALERT_TEMPERATURE,D.TX_ALERT_CAPACITY,D.TX_ALERT_DURATION,D.TX_ALERT_CATEGORY1,D.TX_ALERT_CATEGORY2,
			D.TX_ROOT_REMARK, D.ST_BUSINESS_CYCLE, 'C', 'JOB_USER','JOB_USER'
			FROM CAP_RESULT_THRESHOLD A, "#not_zip_cap_data" B, GT_CAP_LEVEL_9 C, TX_ORIGINAL_PROCESS_DATA D
			WHERE A.R_SQRT>:targetR 
			AND C.FIRST_N IS NOT NULL 
			AND A.BATTERY_ID = C.BATTERY_ID 
			AND A.BATTERY_ID = D.REMARK || ',' ||D.ST_BUSINESS_CYCLE|| ',' || D.STEP_ID
			AND C.VT_TIME = D.SEQUENCE_ID  
			AND B.ST_BUSINESS_CYCLE=D.ST_BUSINESS_CYCLE
			AND B.STEP_ID = D.STEP_ID 
			AND B.REMARK = D.REMARK;
			COMMIT;
			
			current_sample_percentage := :current_sample_percentage + :sample_increase;
			DELETE FROM CAP_RAW 
			WHERE EXISTS (SELECT 1 FROM CAP_RESULT_THRESHOLD WHERE CAP_RESULT_THRESHOLD.R_SQRT>:targetR AND CAP_RAW.BATTERY_ID = CAP_RESULT_THRESHOLD.BATTERY_ID );
			COMMIT;
		END FOR;
		UPDATE TECH_ZIP_STATUS A SET C_STATUS=1 ,MODIFIED_DATE_TIME=CURRENT_TIMESTAMP,MODIFIED_USER='JOB_USER'
		WHERE EXISTS(SELECT 1 FROM "#not_zip_cap_data" B 
		WHERE A.REMARK=B.REMARK AND A.ST_BUSINESS_CYCLE=B.ST_BUSINESS_CYCLE AND A.STEP_ID=B.STEP_ID);
		COMMIT;
		TRUNCATE TABLE "GT_NOT_ZIP_CAP_DATA_ALL";
		
	END IF;
	res := '0';
END;